SystemOrganization addCategory: #'tODE-Metacello'!

TOView subclass: #TOConfiguration
	instanceVariableNames: 'mbConfigurationInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:35'!
classList
	self mbConfigurationInfo ifNil: [ ^#() ].
	^ self mbConfigurationInfo currentVersion currentlyLoadedClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:36'!
extensionClassList
	self mbConfigurationInfo ifNil: [ ^Dictionary new ].
	^ self mbConfigurationInfo currentVersion currentlyLoadedExtensionClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:33'!
mbConfigurationInfo
	mbConfigurationInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbConfigurationInfo := config.
									^ config ] ] ] ].
	^ mbConfigurationInfo! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:06'!
mbConfigurationInfo: anObject
	mbConfigurationInfo := anObject! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:21'!
renderContentOn: html main: main

	self mbConfigurationInfo ifNil: [ html text: 'No configuration'. ^self ].
	self
		renderLink: [ :s | 
			self currentSession push: self mbConfigurationInfo selecting: #view.
			main updateCenterSideHistory: s ]
		with: [ self mbConfigurationInfo renderLabelOn: html main: main ]
		on: html.
	html break.
	self mbConfigurationInfo renderCommandsOn: html for: self main: main.! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:07'!
workingCopy

	^self mbConfigurationInfo workingCopy  ! !

TOView subclass: #TOPackage
	instanceVariableNames: 'mbPackageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:35'!
classList
	
	self mbPackageInfo ifNil: [ ^#() ].
	^ self workingCopy packageInfo classes! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:35'!
extensionClassList
	| classes wc |
	classes := Dictionary new.
	self mbPackageInfo ifNil: [ ^classes ].
	wc := self workingCopy.
	wc packageInfo extensionClasses do: [ :cl | classes at: cl put: (wc packageInfo extensionCategoriesForClass: cl) ].
	^ classes! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:32'!
mbPackageInfo
	mbPackageInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbPackageInfo := pkg.
									^ config ] ] ] ].
	^ mbPackageInfo! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 08:18'!
mbPackageInfo: anObject
	mbPackageInfo := anObject! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:21'!
renderContentOn: html main: main

	self mbPackageInfo ifNil: [ html text: 'No package'. ^self ].
	self
		renderLink: [ :s | 
			self currentSession push: self mbPackageInfo selecting: #view.
			main updateCenterSideHistory: s ]
		with: [ self mbPackageInfo renderLabelOn: html main: main ]
		on: html.
	html break.
	self mbPackageInfo renderCommandsOn: html for: self main: main! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 08:19'!
workingCopy

	^self mbPackageInfo workingCopy  ! !

TOView subclass: #TOPackageClassList
	instanceVariableNames: 'specLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOPackageClassList subclass: #TOConfigurationClassList
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfigurationClassList methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:22'!
configurationInfo

	^(self frame rendererForCenterTab: self specLabel) mbConfigurationInfo! !

!TOConfigurationClassList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:47'!
defaultSpecLabel
	^ #configuration! !

!TOConfigurationClassList methodsFor: 'rendering' stamp: 'dkh 6/13/2011 21:43'!
renderContentOn: html main: main
	| id |
	(html select)
		id: (id := html nextId);
		list: self selectionList;
		selected: self selection;
		callback: [ :index | self selectIndex: index ];
		onChange:
				((html jQuery ajax)
						callback: [ :index | self selectIndex: index ] value: (html jQuery id: id) value;
						script: [ :s | main updateSidebarOn: s ]).
	html break.
	self selection = 'classes'
		ifTrue: [ ^ self renderClassListOn: html main: main ].
	self selection = 'currentVersion'
		ifTrue: [ ^ self renderCurrentVersionOn: html main: main ].
	self selection = 'versions'
		ifTrue: [ ^ self renderVersionListOn: html main: main ]! !

!TOConfigurationClassList methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:24'!
renderCurrentVersionOn: html main: main
	| cvs list cv |
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	cvs := ''.
	(cv := self configurationInfo currentVersion) ~~ nil
		ifTrue: [ cvs := cv versionString , ' ' ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	(html div)
		class: 'naviode';
		with: [ 
					(list := self configurationInfo projects) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'projects --';
								break.
							list
								do: [ :info | 
									| projectConfig |
									(projectConfig := info projectConfiguration) notNil
										ifTrue: [ 
											self
												renderLink: [ :s | 
													self currentSession push: projectConfig selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ]
										ifFalse: [ 
											info renderLabelOn: html main: main.
											html break ] ].
							html break ].
					(list := self configurationInfo packages) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'packages --';
								break.
							list
								do: [ :info | 
									info workingCopy
										ifNil: [ 
											info renderLabelOn: html main: main.
											html break ]
										ifNotNil: [ 
											self
												renderLink: [ :s | 
													self currentSession push: info selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ] ].
							html break ].
					(list := self configurationInfo groups) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'groups --';
								break.
							list do: [ :info | info renderLabelOn: html main: main ] ] ]! !

!TOConfigurationClassList methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:24'!
renderVersionListOn: html main: main
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	(html div)
		class: 'naviode';
		with: [ 
					self configurationInfo project
						ifNil: [ 
							^ (html span)
								class: 'error';
								with: 'no project defined' ].
					html
						text: ' -- baselines --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo baselines)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ 
									info renderLabelOn: html main: main.
									html break ] ].
					html
						break;
						text: ' -- versions --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo versions)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ 
									info renderLabelOn: html main: main.
									html break ] ] ]! !

!TOConfigurationClassList methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:26'!
selectIndex: index

	selection := self selectionList at: index asInteger! !

!TOConfigurationClassList methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:02'!
selection

	selection ifNil: [ selection := 'currentVersion' ].
	^ selection! !

!TOConfigurationClassList methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:56'!
selection: anObject
	selection := anObject! !

!TOConfigurationClassList methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:58'!
selectionList

	^{'classes'. 'currentVersion'. 'versions'. }.
! !

!TOPackageClassList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:47'!
defaultSpecLabel
	^ #package! !

!TOPackageClassList methodsFor: 'rendering' stamp: 'dkh 6/13/2011 20:48'!
renderClassListOn: html main: main
	| order classes indents displayString classList extensionClassList |
	order := SortedCollection
		sortBlock: [ :assoc1 :assoc2 | 
			| result chain1 chain2 max i |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[ result isNil and: [ i <= max ] ]
				whileTrue: [ 
					(chain1 at: i) = (chain2 at: i)
						ifTrue: [ i := i + 1 ]
						ifFalse: [ result := (chain1 at: i) name < (chain2 at: i) name ] ].
			result isNil
				ifTrue: [ chain1 size < chain2 size ]
				ifFalse: [ result ] ].
	classList := (self frame rendererForCenterTab: self specLabel) classList.
	extensionClassList := (self frame rendererForCenterTab: self specLabel) extensionClassList.
	classList
		do: [ :cl | extensionClassList removeKey: cl ifAbsent: []].
	classes :=  classList, extensionClassList keys.
	classes
		do: [ :cl | 
			| supersChain |
			supersChain := cl withAllSuperclasses reversed.
			supersChain removeAllSuchThat: [ :class | (classes includes: class) not ].
			order add: supersChain contents -> cl ].
	indents := IdentityDictionary new.
	order do: [ :assoc | indents at: assoc value put: assoc key size - 1 ].
	classes := classes asArray sorted: [ :a :b | a name <= b name ].
	order
		do: [ :assoc | 
			| cl |
			cl := assoc value.
			(indents at: cl) * 2 timesRepeat: [ html space ].
			self
				renderLink: [ :s | | fr |
					fr := self currentSession push: cl selecting: ((extensionClassList includesKey: cl)
								ifTrue: [#methodSourceBrowser]
								ifFalse: [#classBrowser]).
					(extensionClassList includesKey: cl)
						ifTrue: [| browser selector |
							browser := fr rendererForCenterTab: #methodSourceBrowser.
							selector := (cl organization listAtCategoryNamed: (extensionClassList at: cl) first) first.
							browser methodReference: (MethodReference class: cl selector: selector) ].
					main updateCenterSideHistory: s ]
				with: [ 
					(extensionClassList includesKey: cl)
								ifTrue: [html text: cl name asString]
								ifFalse: [html strong: cl name asString].
					html break ]
				on: html ]! !

!TOPackageClassList methodsFor: 'rendering' stamp: 'dkh 6/13/2011 20:49'!
renderContentOn: html main: main
	self renderClassListOn: html main: main! !

!TOPackageClassList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:48'!
specLabel
	specLabel ifNil: [ specLabel := self defaultSpecLabel ].
	^ specLabel! !

!TOPackageClassList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:48'!
specLabel: aSymbol
	specLabel := aSymbol ! !

!TOSystem methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 16:06'!
configurationRoot

	^MBConfigurationRoot current! !

!MBCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^false! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/11/2011 17:55'!
renderCommandOn: html for: aTOMetacelloView main: main
	aTOMetacelloView
		renderButton: [ :s | 
			self execute.
			main updateCenterSideHistory: s ]
		label: self todeTitle
		on: html! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:39'!
todeTitle

	^self title! !

!MBRevertPackageCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^true! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 08:36'!
basePackageName
	^ target workingCopy packageName copyUpToLast: #-! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 08:36'!
renderCommandOn: html for: aTOInspector main: main
	| selectedName ancestors ancestorNames id ajax |
	ancestors := target workingCopy ancestry breadthFirstAncestors.
	ancestorNames := ancestors collect: [ :ea | ea name ].
	selectedName := ancestorNames first.
	(html select)
		id: (id := html nextId);
		list: ancestorNames;
		selected: selectedName;
		onChange: (html jQuery ajax callback: [ :value | selectedName := value ] value: (html jQuery id: id) value).
	ajax := html jQuery ajax.
	target workingCopy modified
		ifTrue: [ 
			ajax
				confirm:
					'You are about to load a new version of ' , self basePackageName printString
						, ' that has unsaved changes in the image.  If you continue, you will lose these changes?' ].
	ajax
		script: [ :s | 
			self
				revertPackage: (ancestors at: (ancestorNames indexOf: selectedName))
				for: aTOInspector
				script: s
				main: main ].
	(html submitButton)
		onClick: ajax;
		with: self todeTitle! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:15'!
revertPackage: info for: aTOInspector script: s main: main
	"unconditional loading by the time this method is called ... overrides modified packages."

	[ 
	(target workingCopy repositoryGroup versionWithInfo: info ifNone: [ ^ s alert: 'No repository found for ' , info name ])
		load ] on: Warning do: [ :ex | ex resume: true ].
	s alert: 'Reverted: ' , info name.
	main updateCenterSideHistory: s! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 08:08'!
configurationQueryResults
	<todeSearch: 'Configurations' selector: #configurationSearch priority: 35>
	^ (MBConfigurationRoot current configurations select: [ :ci | ci name includesSubstring: searchText caseSensitive: false ]) sorted: [ :a :b | a name <= b name ]! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 07:42'!
packageQueryResults
	<todeSearch: 'Packages' selector: #packageSearch priority: 30>
	^ (MCWorkingCopy allManagers select: [ :wc | wc packageName includesSubstring: searchText caseSensitive: false ])
		sorted: [ :a :b | a packageName <= b packageName ]! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 21:13'!
renderStyledLabelOn: html main: main
	| string wc loadedPkgName cssSpanClass |
	string := super buildStringOrText.
	(wc := self workingCopy) isNil
		ifTrue: [ ^ string ].
	cssSpanClass := ''.
	wc ancestry ancestors notEmpty
		ifTrue: [ 
			loadedPkgName := wc ancestry ancestors first name.
			loadedPkgName = self name
				ifFalse: [ 
					(self compareWorkingCopyNamed: loadedPkgName using: #<=)
						ifTrue: [ cssSpanClass := 'outofspec ' ].
					cssSpanClass := cssSpanClass , 'mismatch ' ] ].
	self isDirty
		ifTrue: [ cssSpanClass := cssSpanClass , 'dirty ' ].
	cssSpanClass isEmpty
		ifTrue: [ ^ html text: string ].
	^ (html span)
		class: cssSpanClass;
		with: string! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 10:20'!
renderViewContentOn: html spec: aTOTabSpec main: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 09:50'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		renderer:
				((TOPackageClassList new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 09:49'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		renderer: ((TOPackage new)
			mbPackageInfo: self;
			yourself);  
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		sidebarSpec: self tODEViewSidebarSpec;
		renderSelector: #renderViewContentOn:spec:main:! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/11/2011 17:55'!
renderCommandsOn: html for: aTOMetacelloView main: main
	| commands |
	commands := ((self commands select: [ :each | each istODECommand ])
		collect: [ :commandClass | commandClass target: self for: nil ]) asArray sort: [ :a :b | a order <= b order ].
	commands isEmpty
		ifTrue: [ ^ self ].
	html horizontalRule.
	commands do: [ :command | 
		command renderCommandOn: html for: aTOMetacelloView main: main.
		html space ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 21:13'!
renderLabelOn: html main: main
	(html div)
		class: 'naviode';
		with: [ self renderStyledLabelOn: html main: main ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 21:12'!
renderStyledLabelOn: html main: main

	html text: self printString! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 21:13'!
renderStyledLabelOn: html main: main
	| string cv specVersion wc cssSpanClass |
	[ string := super buildStringOrText ]
		on: Error
		do: [ :ex | 
			^ (html span)
				class: 'error';
				with: string ].
	cssSpanClass := ''.
	((wc := self workingCopy) notNil and: [ wc needsSaving ])
		ifTrue: [ cssSpanClass := 'dirty ' ].
	self currentVersion.	"prime the pump"
	currentVersion == #notLoaded
		ifTrue: [ 
			cssSpanClass isEmpty
				ifTrue: [ html text: string ].
			^ (html span)
				class: cssSpanClass;
				with: string ].
	super isDirty | self currentVersionMismatch
		ifTrue: [ cssSpanClass := 'mismatch ', cssSpanClass ].
	self currentVersion versionStatus == #somethingLoaded
		ifTrue: [ cssSpanClass := cssSpanClass , 'somethingloaded ' ].
	cssSpanClass isEmpty
		ifTrue: [ ^ html text: string ].
	^ (html span)
		class: cssSpanClass;
		with: string! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 21:02'!
renderMetacelloSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 17:06'!
renderMetacelloTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 21:28'!
tODEConfigurationSidebarSpec
	^ {((TOTabSpec new)
		id: #configurationClasses;
		rendererClass: TOConfigurationClassList;
		receiver: self;
		label: 'configuration classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:14'!
tODEConfigurationTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #configuration;
		rendererClass: TOConfiguration;
		receiver: self;
		label: 'configuration';
		order: 10;
		group: 'monticello';
		sidebarSpec: self tODEConfigurationSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 20:52'!
tODEPackageSidebarSpec
	^ {((TOTabSpec new)
		id: #packageClasses;
		rendererClass: TOPackageClassList;
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:20'!
tODEPackageTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #package;
		rendererClass: TOPackage;
		receiver: self;
		label: 'package';
		order: 20;
		group: 'monticello';
		sidebarSpec: self tODEPackageSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !
